import java.awt.*;
import javax.swing.*;

public class BMSearch {
	
        public static int CX[] = new int[42];
        public static int CY[] = new int[42];       
	    public static int count = 0;
	    
	// last-Tabelle initialisieren
	private static int[] initLast(String pat) {
		int[] last = new int[256];
		int i;
		
		for (i = 0; i < 256; i++) 
			last[i] = -1;
		for (i = 0; i < pat.length(); i++)
			last[pat.charAt(i)] = i;
		return last;
	}
	
	// shift-Tabelle initialisieren
	private static int[] initShift(String pat) {
		int m = pat.length();
		int[] shift = new int[m + 1];
		int[] suffix = new int[m + 1];
		
		int i, j, h = 0;
		suffix[m - 1] = m;
		j = m - 1;
		for (i = m - 2; i >= 0; i--) {
			if (i > j && suffix[i + m - 1 - h] < i - j)
				suffix[i] = suffix[i + m - 1 - h];
			else {
				if (i < j) 
					j = i;
				h = i;
				while (j >= 0 && 
						pat.charAt(j) == 
							pat.charAt(j+m-1-h))
					j--;
				suffix[i] = h - j;
			}
		}
		
		for (i = 0; i < m; i++)
			shift[i] = m;
		j = 0;
		for (i = m - 1; i >= -1; i--)
			if (i == -1 || suffix[i] == i + 1)
				while (j < m - 1 - i) {
					if (shift[j] == m)
						shift[j] = m - 1 - i;
					j++;
				}
		for (i = 0; i < m - 1; i++)
			shift[m - 1 - suffix[i]] = m - i - 1;
		return shift;
	}
	
	
	// Suchfunktion
	public static int bmSearch(String text, String pat, JFrame F , Graphics g ) {
		
		 double L= pat.length();
		
		
		
		int last[] = initLast(pat);
		int shift[] = initShift(pat);
		
		int i = 0;
		int f = 550;
	//----------------------------------------------
		int  anw = 0;
		
		
	//----------------------------------------------
		
		while (i <= text.length() - pat.length()) {
			
			
	
			   
			int j = pat.length() - 1; 
			
			/*----*/
			 anw++;
			 /*----*/
			     
			while (j >= 0 && pat.charAt(j) == text.charAt(i+j)) 
				
				j--;
				
				/*----*/
			    anw++;
			    
			    
			    /*----*/
			    
			if (j < 0) {
			
			    anw++;
			//Kordinaten Zeichen----------------------------------------------------------
			
			        int X   = (int)(150 + L*30); 
			     	double Y = 0;
			     	
			     	if (i != 1 ){ 
			        
			        Y = 720-(100*anw/(i-1));
			         
			         }
			    
			        if (Y < 120 ) {
			        
			        Y = 120;	
			        }
			        
			         if (Y > 720 ) {
			        
			        Y = 720;	
			        }
			    
			    
			      CX[count] = X ;
			     
			      CY[count] = (int)Y ;
			   
			  	  count++;
			  	
			  
			 
                              
			   g.fillRect(X,(int)Y,3,3);
			     
			 //----------------------------------------------------------------------
				return i;
			}
				
			else {
			
				i += Math.max(shift[j], j - last[text.charAt(i+j)]);
				
		     /*----*/
			 anw++;
			 /*----*/
				
			
				
				
			
				
			}
		}
		return -1;
	}
}
